import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout, check_source
from functools import reduce
import os

exercise = 'src.square_of_hashes'

def cor_shape(y_height, y_character):
    i = 1
    lines = []
    while i<=y_height:
        lines.append(y_character*y_height)
        i += 1

    return lines

@points('1.square_of_hashes')
class SquareOfHashesTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=["2"] * 10):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.square_of_hashes import square_of_hashes
        except:
            self.assertTrue(False, f'Din kod bör innehålla en funktion som heter square_of_hashes')
        try:
            from src.square_of_hashes import square_of_hashes
            square_of_hashes(5)
        except:
            self.assertTrue(False, f'Se till att den funktionen kan kallas enligt följande:\rsquare_of_hashes(5)')

    def test_2_square_of_hashes_ok(self):
        for y_height, y_character in [(5, "+"),(3, "X"), (4, "x"), (4, "x"),(5, "o"), (1, "^"), (3, "z") ,(20, "@") ]:
            with patch('builtins.input', side_effect=["2"] * 10):
                reload_module(self.module)
                output_at_start = get_stdout()
                from src.square_of_hashes import square_of_hashes
                square_of_hashes(y_height)
                output_all = get_stdout().replace(output_at_start, '', 1)
                
                output = [l for l in output_all.split("\n") if len(l.strip())>0 ]

                exp = cor_shape(y_height, "#")

                self.assertTrue(len(output_all)>0, f'Att anropa square_of_hashes({y_height}) skriver inte ut någonting')
                acual = '\n'.join(output)
                self.assertEqual(len(exp), len(output), f'Att anropa square_of_hashes({y_height}) ska skriva ut {len(exp)} rader, nu skriver den ut {len(output)} rader, utskriften var\n{acual}')
                for i in range(len(exp)):
                    self.assertEqual(exp[i], output[i].strip(), f'Raden {i+1} som skrivs ut efter att ha anropat square_of_hashes({y_height}) ska vara:\n{exp[i]}\nmen det är:\n{output[i]}\nHela utskriften av funktionen var\n{output_all}')

    def test_function_line_in_use(self):
        src_file = os.path.join('src', 'square_of_hashes.py')
        with open(src_file) as f:
            in_function = False
            for line in f:
                if 'def square_of_hashes' in line:
                    in_function = True
                elif 'def line' in line:
                    in_function = False
                elif line[0] != " " and line[0] != "#":
                    in_function = False

                if in_function:
                    if '  print' in line:
                        self.assertTrue(False, f"Funktion square_of_hashes ska inte använda utskriftskommandon för utskrift, så följande rad är inte tillåten i din kod\n{line}")

if __name__ == '__main__':
    unittest.main()